/**
 * ValidatorConfiguration.java
 *
 * File generated from the XValidator::ValidatorConfiguration uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.UniqueConstraint;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.namespace.NamespaceContext;

import net.ihe.gazelle.xvalidation.core.utils.SVSConsumer;
import net.ihe.gazelle.xvalidation.core.utils.ValueSetProvider;
import net.ihe.gazelle.xvalidation.core.xpath.ValidatorNamespaceContext;

import org.w3c.dom.Node;

// End of user code

/**
 * Description of the class ValidatorConfiguration.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ValidatorConfiguration", propOrder = { "namespaces", "valueSetProviderUrl", "assertionManagerUrl", "dicomLibrary" })
@XmlRootElement(name = "ValidatorConfiguration")
@Entity
@Table(name = "xval_validator_configuration", schema = "public")
@SequenceGenerator(name = "xval_validator_configuration_sequence", sequenceName = "xval_validator_configuration_id_seq", allocationSize = 1)
public class ValidatorConfiguration implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@XmlTransient
	@GeneratedValue(generator = "xval_validator_configuration_sequence", strategy = GenerationType.SEQUENCE)
	@Column(name = "id", unique = true, nullable = false)
	private Integer id;

	@XmlElement(name = "NamespaceDeclaration")
	@ManyToMany(cascade = { CascadeType.MERGE, CascadeType.PERSIST })
	@JoinTable(name = "xval_validator_configuration_namespace", joinColumns = @JoinColumn(name = "configuration_id"), inverseJoinColumns = @JoinColumn(name = "namespace_id"), uniqueConstraints = @UniqueConstraint(columnNames = {
			"configuration_id", "namespace_id" }))
	private List<Namespace> namespaces;

	@XmlElement(name = "ValueSetProviderUrl")
	@Column(name = "value_set_provider_url")
	private String valueSetProviderUrl;
	
	@XmlElement(name = "AssertionManagerUrl")
	@Column(name = "assertion_manager_url")
	private String assertionManagerUrl;


	/**
	 * The library used to dump the DICOM objects into XML
	 */
	@XmlElement(name = "DICOMLibrary")
	@Column(name = "dicom_library")
	private DICOMLibrary dicomLibrary;

	@XmlTransient
	@OneToOne
	@JoinColumn(name = "validator_id")
	private GazelleCrossValidatorType validator;

	private transient ValueSetProvider valueSetProvider;

	private transient NamespaceContext namespaceContext;

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	public ValidatorConfiguration(GazelleCrossValidatorType gazelleCrossValidatorType) {
		this.validator = gazelleCrossValidatorType;
	}
	
	public ValidatorConfiguration() {
		super();
	}

	/**
	 * Return namespaceDeclaration.
	 *
	 * @return namespaceDeclaration
	 */
	public List<Namespace> getNamespaces() {
		if (namespaces == null) {
			namespaces = new ArrayList<Namespace>();
		}
		return namespaces;
	}

	/**
	 * Set a value to attribute namespaceDeclaration.
	 *
	 * @param namespaceDeclaration
	 *            .
	 */
	public void setNamespaces(List<Namespace> namespaceDeclaration) {
		this.namespaces = namespaceDeclaration;
	}

	/**
	 * Add a namespaceDeclaration to the namespaceDeclaration collection.
	 *
	 * @param namespaceDeclarationElement
	 *            Element to add.
	 */
	public void addNamespace(Namespace namespaceDeclarationElement) {
		this.getNamespaces().add(namespaceDeclarationElement);
	}

	/**
	 * Remove a namespaceDeclaration to the namespaceDeclaration collection.
	 *
	 * @param namespaceDeclarationElement
	 *            Element to remove
	 */
	public void removeNamespace(Namespace namespaceDeclarationElement) {
		this.getNamespaces().remove(namespaceDeclarationElement);
	}

	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "ValidatorConfiguration", this);
		}
		return xmlNodePresentation;
	}

	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public GazelleCrossValidatorType getValidator() {
		return validator;
	}

	public void setValidator(GazelleCrossValidatorType validator) {
		this.validator = validator;
	}

	public String getValueSetProviderUrl() {
		return valueSetProviderUrl;
	}

	public void setValueSetProviderUrl(String valueSetProviderUrl) {
		this.valueSetProviderUrl = valueSetProviderUrl;
	}

	public ValueSetProvider getValueSetProvider() {
		if (valueSetProvider == null) {
			if (valueSetProviderUrl == null) {
				valueSetProvider = new SVSConsumer();
			} else {
				valueSetProvider = new SVSConsumer() {
					@Override
					protected String getSVSRepositoryUrl() {
						return valueSetProviderUrl;
					};
				};
			}
		}
		return valueSetProvider;
	}

	public void setValueSetProvider(ValueSetProvider valueSetProvider) {
		this.valueSetProvider = valueSetProvider;
	}

	public NamespaceContext getNamespaceContext() {
		if ((namespaceContext == null) && (namespaces != null) && !namespaces.isEmpty()) {
			namespaceContext = new ValidatorNamespaceContext(namespaces);
		}
		return namespaceContext;
	}

	public void setNamespaceContext(NamespaceContext namespaceContext) {
		this.namespaceContext = namespaceContext;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = (prime * result) + ((namespaces == null) ? 0 : namespaces.hashCode());
		result = (prime * result) + ((valueSetProviderUrl == null) ? 0 : valueSetProviderUrl.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		ValidatorConfiguration other = (ValidatorConfiguration) obj;
		if (namespaces == null) {
			if (other.namespaces != null) {
				return false;
			}
		} else if (!namespaces.equals(other.namespaces)) {
			return false;
		}
		if (valueSetProviderUrl == null) {
			if (other.valueSetProviderUrl != null) {
				return false;
			}
		} else if (!valueSetProviderUrl.equals(other.valueSetProviderUrl)) {
			return false;
		}
		return true;
	}

	public DICOMLibrary getDicomLibrary() {
		if (dicomLibrary == null){
			dicomLibrary = DICOMLibrary.NA;
		}
		return dicomLibrary;
	}

	public void setDicomLibrary(DICOMLibrary dicomLibrary) {
		this.dicomLibrary = dicomLibrary;
	}

	public String getAssertionManagerUrl() {
		return assertionManagerUrl;
	}

	public void setAssertionManagerUrl(String assertionManagerUrl) {
		this.assertionManagerUrl = assertionManagerUrl;
	}

}